<?php

namespace Pepitelabs\PWS;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'GetQuickEstimateRequestContainer' => '\\Pepitelabs\\PWS\\EstimatingService\\GetQuickEstimateRequestContainer',
            'RequestContainer' => '\\Pepitelabs\\PWS\\EstimatingService\\RequestContainer',
            'ShortAddress' => '\\Pepitelabs\\PWS\\EstimatingService\\ShortAddress',
            'TotalWeight' => '\\Pepitelabs\\PWS\\EstimatingService\\TotalWeight',
            'RequestContext' => '\\Pepitelabs\\PWS\\EstimatingService\\RequestContext',
            'GetQuickEstimateResponseContainer' => '\\Pepitelabs\\PWS\\EstimatingService\\GetQuickEstimateResponseContainer',
            'ResponseContainer' => '\\Pepitelabs\\PWS\\EstimatingService\\ResponseContainer',
            'ResponseInformation' => '\\Pepitelabs\\PWS\\EstimatingService\\ResponseInformation',
            'ArrayOfError' => '\\Pepitelabs\\PWS\\EstimatingService\\ArrayOfError',
            'Error' => '\\Pepitelabs\\PWS\\EstimatingService\\Error',
            'ArrayOfInformationalMessage' => '\\Pepitelabs\\PWS\\EstimatingService\\ArrayOfInformationalMessage',
            'InformationalMessage' => '\\Pepitelabs\\PWS\\EstimatingService\\InformationalMessage',
            'ArrayOfShipmentEstimate' => '\\Pepitelabs\\PWS\\EstimatingService\\ArrayOfShipmentEstimate',
            'ShipmentEstimate' => '\\Pepitelabs\\PWS\\EstimatingService\\ShipmentEstimate',
            'ArrayOfSurcharge' => '\\Pepitelabs\\PWS\\EstimatingService\\ArrayOfSurcharge',
            'Surcharge' => '\\Pepitelabs\\PWS\\EstimatingService\\Surcharge',
            'ArrayOfTax' => '\\Pepitelabs\\PWS\\EstimatingService\\ArrayOfTax',
            'Tax' => '\\Pepitelabs\\PWS\\EstimatingService\\Tax',
            'ArrayOfOptionPrice' => '\\Pepitelabs\\PWS\\EstimatingService\\ArrayOfOptionPrice',
            'OptionPrice' => '\\Pepitelabs\\PWS\\EstimatingService\\OptionPrice',
            'ResponseContext' => '\\Pepitelabs\\PWS\\EstimatingService\\ResponseContext',
            'GetFullEstimateRequestContainer' => '\\Pepitelabs\\PWS\\EstimatingService\\GetFullEstimateRequestContainer',
            'Shipment' => '\\Pepitelabs\\PWS\\EstimatingService\\Shipment',
            'SenderInformation' => '\\Pepitelabs\\PWS\\EstimatingService\\SenderInformation',
            'Address' => '\\Pepitelabs\\PWS\\EstimatingService\\Address',
            'PhoneNumber' => '\\Pepitelabs\\PWS\\EstimatingService\\PhoneNumber',
            'ReceiverInformation' => '\\Pepitelabs\\PWS\\EstimatingService\\ReceiverInformation',
            'FromOnLabelInformation' => '\\Pepitelabs\\PWS\\EstimatingService\\FromOnLabelInformation',
            'PackageInformation' => '\\Pepitelabs\\PWS\\EstimatingService\\PackageInformation',
            'ArrayOfPiece' => '\\Pepitelabs\\PWS\\EstimatingService\\ArrayOfPiece',
            'Piece' => '\\Pepitelabs\\PWS\\EstimatingService\\Piece',
            'Weight' => '\\Pepitelabs\\PWS\\EstimatingService\\Weight',
            'Dimension' => '\\Pepitelabs\\PWS\\EstimatingService\\Dimension',
            'ArrayOfOptionIDValuePair' => '\\Pepitelabs\\PWS\\EstimatingService\\ArrayOfOptionIDValuePair',
            'OptionIDValuePair' => '\\Pepitelabs\\PWS\\EstimatingService\\OptionIDValuePair',
            'OptionsInformation' => '\\Pepitelabs\\PWS\\EstimatingService\\OptionsInformation',
            'InternationalInformation' => '\\Pepitelabs\\PWS\\EstimatingService\\InternationalInformation',
            'ArrayOfContentDetail' => '\\Pepitelabs\\PWS\\EstimatingService\\ArrayOfContentDetail',
            'ContentDetail' => '\\Pepitelabs\\PWS\\EstimatingService\\ContentDetail',
            'BuyerInformation' => '\\Pepitelabs\\PWS\\EstimatingService\\BuyerInformation',
            'DutyInformation' => '\\Pepitelabs\\PWS\\EstimatingService\\DutyInformation',
            'ReturnShipmentInformation' => '\\Pepitelabs\\PWS\\EstimatingService\\ReturnShipmentInformation',
            'ReturnShipment' => '\\Pepitelabs\\PWS\\EstimatingService\\ReturnShipment',
            'PaymentInformation' => '\\Pepitelabs\\PWS\\EstimatingService\\PaymentInformation',
            'CreditCardInformation' => '\\Pepitelabs\\PWS\\EstimatingService\\CreditCardInformation',
            'PickupInformation' => '\\Pepitelabs\\PWS\\EstimatingService\\PickupInformation',
            'NotificationInformation' => '\\Pepitelabs\\PWS\\EstimatingService\\NotificationInformation',
            'TrackingReferenceInformation' => '\\Pepitelabs\\PWS\\EstimatingService\\TrackingReferenceInformation',
            'OtherInformation' => '\\Pepitelabs\\PWS\\EstimatingService\\OtherInformation',
            'ProactiveNotification' => '\\Pepitelabs\\PWS\\EstimatingService\\ProactiveNotification',
            'ArrayOfSubscription' => '\\Pepitelabs\\PWS\\EstimatingService\\ArrayOfSubscription',
            'Subscription' => '\\Pepitelabs\\PWS\\EstimatingService\\Subscription',
            'GetFullEstimateResponseContainer' => '\\Pepitelabs\\PWS\\EstimatingService\\GetFullEstimateResponseContainer',
            'ValidationFault' => '\\Pepitelabs\\PWS\\EstimatingService\\ValidationFault',
            'ArrayOfValidationDetail' => '\\Pepitelabs\\PWS\\EstimatingService\\ArrayOfValidationDetail',
            'ValidationDetail' => '\\Pepitelabs\\PWS\\EstimatingService\\ValidationDetail',
        );
    }
}
